#!/opt/puppet/bin/ruby

require 'trollop'
require 'pathname'
require 'timeout'

opts = Trollop::options do
  opt :server, 'scvmm server address', :type => :string, :required => true
  opt :port, 'scvmm server port', :default => 5985
  opt :username, 'scvmm server username', :type => :string, :required => true
  opt :password, 'scvmm server password', :type => :string, :required => true
  opt :timeout, 'command timeout', :default => 180
end

begin
  Timeout.timeout(opts[:timeout]) do
    # intentionally doing this to let it finish
    folder = Pathname.new(__FILE__).parent
    `#{folder}/scvmm_facts.rb --server #{opts[:server]} --port #{opts[:port]} --username '#{opts[:username]}' --password '#{opts[:password]}'`
  end
rescue Timeout::Error
  exit 1
ensure
  scvmm_json = File.join('/opt/Dell/ASM/cache', "#{opts[:server]}.json")
  if File.exists? scvmm_json
    puts File.read(scvmm_json)
    exit 0
  else
    puts 'scvmm host does not exist'
    exit 1
  end
end
